Attribute VB_Name = "Module1"
Type cmd
 C As String
 arg1 As String
 arg2 As String
 arg3 As String
 lab As String
 pos As Integer
End Type
Global mem(256) As Byte             'CPU Memory
Global memtmp(256) As Byte          'Buffer for copying
Global IP As Byte                   'Instruction pointer
Global cmds() As cmd                'internal command list
Global cmdc As Integer              'count of commands
Global history(512) As Long         'history of memory sum
Global Pbuf(256, 256) As Long       'screenbuffer for graphics
Global Bcolor As Long               'backgroundcolor


Sub ProcessLine(s As String)
On Error GoTo ErrHandler
Dim l() As String
l = Split(s, ",")
n = UBound(l)
If Mid(l(0), 1, 1) = ":" Then
    cmdc = cmdc + 1
    ReDim Preserve cmds(cmdc)
    With cmds(cmdc - 1)
        .C = "LAB"
        .arg1 = ""
        .arg2 = ""
        .arg3 = ""
        .lab = Mid(l(0), 2, Len(l(0)) - 1)
    End With
End If
If Mid(l(0), 1, 1) = "#" Then
End If
Select Case Mid(l(0), 1, 3)
    Case "NUL", "NXT":
        cmdc = cmdc + 1
        ReDim Preserve cmds(cmdc)
        With cmds(cmdc - 1)
            .C = l(0)
            .arg1 = ""
            .arg2 = ""
            .arg3 = ""
            .lab = ""
        End With
    Case "SET", "POS", "GTO", "VAL":
        cmdc = cmdc + 1
        ReDim Preserve cmds(cmdc)
        With cmds(cmdc - 1)
            .C = l(0)
            .arg1 = l(1)
            .arg2 = ""
            .arg3 = ""
            .lab = ""
        End With
    Case "MOV":
        cmdc = cmdc + 1
        ReDim Preserve cmds(cmdc)
        With cmds(cmdc - 1)
            .C = l(0)
            .arg1 = l(1)
            .arg2 = l(2)
            .arg3 = ""
            .lab = ""
        End With
    Case "SUB":
        cmdc = cmdc + 1
        ReDim Preserve cmds(cmdc)
        With cmds(cmdc - 1)
            .C = l(0)
            .arg1 = l(1)
            .arg2 = l(2)
            .arg3 = l(3)
            .lab = ""
        End With
End Select
Exit Sub
ErrHandler:
MsgBox "Input Processing failed at: " & s
End Sub

Sub ScanText()
On Error GoTo ErrHandler
Dim st, p, t As String, s2 As String
cmdc = 0
t = Form2.rtb1.Text
p = 1
st = 1
lines:
s = Mid(t, p, 1)
If s = Chr(10) Then
 s2 = Mid(Form2.rtb1.Text, st, p - st - 1)
 st = p + 1
 ProcessLine s2
End If
p = p + 1
If p > Len(t) Then
 s2 = Mid(Form2.rtb1.Text, st, p - st)
 ProcessLine s2
 GoTo fin
End If
GoTo lines:
fin:
ShowInternCmds
Exit Sub
ErrHandler:
MsgBox "Text Scan failed at: " & p
End Sub

Sub ShowInternCmds()
On Error Resume Next
Form3.rtb1.Text = ""
s = "CMD" & Chr(9) & "ARG 1" & Chr(9) & "ARG 2" & Chr(9) & "ARG 3" & Chr(9) & "LABEL" & Chr(9) & "POS" & Chr(13)
For i = 0 To cmdc - 1
 With cmds(i)
  s = s & .C & Chr(9) & .arg1 & Chr(9) & .arg2 & Chr(9) & .arg3 & Chr(9) & .lab & Chr(9) & .pos & Chr(13)
 End With
Next
Form3.rtb1.Text = s
End Sub
Sub ProcessCmds()
On Error GoTo ErrHandler
i = 0
1: 'Finde Labels
 Select Case cmds(i).C
    Case "LAB":
        cmds(i + 1).lab = cmds(i).lab
        For j = i To cmdc - 2
         cmds(j) = cmds(j + 1)
        Next
        cmdc = cmdc - 1
        ReDim Preserve cmds(cmdc) As cmd
        i = i - 1
 End Select
i = i + 1
If i <= cmdc Then GoTo 1

pos = 0 'Position bestimmen
i = 0
2:
  Select Case cmds(i).C
    Case "NUL", "SET", "POS", "VAL", "NXT":
        cmds(i).pos = pos
        pos = pos + 1
    Case "GTO", "SUB", "ADD":
        cmds(i).pos = pos
        pos = pos + 3
    Case "MOV":
        cmds(i).pos = pos
        pos = pos + 3
        If IsNumeric(cmds(i).arg2) Then
            Dim nn, np
            nn = 256 - Val(cmds(i).arg2)
            If nn = 256 Then nn = 0
            np = -1
            For j = 0 To cmdc - 1
             If cmds(j).C = "VAL" And cmds(j).arg1 = nn Then np = i
            Next
            If np = -1 Then
                cmdc = cmdc + 1
                ReDim Preserve cmds(cmdc) As cmd
                cmds(cmdc - 1).C = "VAL"
                cmds(cmdc - 1).arg1 = nn
            End If
        End If
  End Select
  i = i + 1
If i <= cmdc Then GoTo 2
ShowInternCmds
Exit Sub
ErrHandler:
MsgBox "Input Processing failed at: " & pos
End Sub

Sub Compile(dbg As Boolean, run As Boolean, copyonly As Boolean)
On Error GoTo ErrHandler
Form4.rtb1.Text = ""
s = ""
pos = 0
If run Or copyonly Then
 For i = 0 To 255
  mem(i) = 0
  memtmp(i) = 0
 Next
 Form1.Timer1.Enabled = False
End If
For i = 0 To cmdc - 1
    If dbg Then s = s & "----" & cmds(i).C & "----" & Chr(10)
    Select Case cmds(i).C
        Case "MOV":
            a = -1
            b = -1
            For j = 0 To cmdc - 1
                If cmds(j).C = "SET" And cmds(j).arg1 = cmds(i).arg1 Then a = cmds(j).pos
            Next
            For j = 0 To cmdc - 1
                If cmds(j).C = "VAL" Then
                    If cmds(j).arg1 = 256 - Val(cmds(i).arg2) Then b = cmds(j).pos
                    If Val(cmds(i).arg2) = 0 Then
                       If cmds(j).arg1 = 0 Then b = cmds(j).pos
                    End If
                End If
            Next
            pos = pos + 3
            memtmp(pos - 3) = a
            memtmp(pos - 2) = b
            memtmp(pos - 1) = pos
            s = s & (pos - 3) & Chr(9) & ":" & a & Chr(10) & (pos - 2) & Chr(9) & ":" & b & Chr(10) & (pos - 1) & Chr(9) & ":" & pos & Chr(10)
        Case "POS":
            a = -1
            For j = 0 To cmdc - 1
                If cmds(j).C = "SET" And cmds(j).arg1 = cmds(i).arg1 Then a = cmds(j).pos
            Next
            pos = pos + 1
            memtmp(pos - 1) = a
            s = s & (pos - 1) & Chr(9) & ":" & a & Chr(10)
        Case "SET", "NUL":
            pos = pos + 1
            memtmp(pos - 1) = 0
            s = s & (pos - 1) & Chr(9) & ":" & "0" & Chr(10)
        Case "NXT":
            pos = pos + 1
            memtmp(pos - 1) = pos
            s = s & (pos - 1) & Chr(9) & ":" & pos & Chr(10)
        Case "VAL":
            pos = pos + 1
            memtmp(pos - 1) = Val(cmds(i).arg1)
            s = s & (pos - 1) & Chr(9) & ":" & cmds(i).arg1 & Chr(10)
        Case "GTO":
            a = -1
            For j = 0 To cmdc - 1
                If cmds(j).lab = cmds(i).arg1 Then a = cmds(j).pos
            Next
            pos = pos + 3
            memtmp(pos - 3) = 255
            memtmp(pos - 2) = 255
            memtmp(pos - 1) = a
            s = s & (pos - 3) & Chr(9) & ":" & "255" & Chr(10) & (pos - 2) & Chr(9) & ":" & "255" & Chr(10) & (pos - 1) & Chr(9) & ":" & a & Chr(10)
        Case "SUB":
            a = -1
            b = -1
            C = -1
            If IsNumeric(cmds(i).arg1) Then
                a = Val(cmds(i).arg1)
            Else
                For j = 0 To cmdc - 1
                    If cmds(j).C = "SET" And cmds(j).arg1 = cmds(i).arg1 Then a = cmds(j).pos
                Next
            End If
            If IsNumeric(cmds(i).arg2) Then
                b = Val(cmds(i).arg2)
            Else
                For j = 0 To cmdc - 1
                    If cmds(j).C = "SET" And cmds(j).arg1 = cmds(i).arg2 Then b = cmds(j).pos
                Next
            End If
            If cmds(i).arg3 = "?" Then
                C = pos + 3
            Else
                For j = 0 To cmdc - 1
                    If cmds(j).lab = cmds(i).arg3 Then C = cmds(j).pos
                Next
            End If
            pos = pos + 3
            memtmp(pos - 3) = a
            memtmp(pos - 2) = b
            memtmp(pos - 1) = C
            s = s & (pos - 3) & Chr(9) & ":" & a & Chr(10) & (pos - 2) & Chr(9) & ":" & b & Chr(10) & (pos - 1) & Chr(9) & ":" & C & Chr(10)
    End Select
Next
If run Or copyonly Then
 For i = 0 To 255
  mem(i) = memtmp(i)
 Next
 IP = 0
 Form1.DrawMemory
 If run Then Form1.Timer1.Enabled = True
End If
Form4.rtb1.Text = s
Exit Sub
ErrHandler:
MsgBox "Compile Failed at command: " & i & " = " & cmds(i).C & "," & cmds(i).arg1 & "," & cmds(i).arg2 & "," & cmds(i).arg3
End Sub

Sub CheckPaintJob()
Dim x As Byte, y As Byte, r As Byte, g As Byte, b As Byte, pcmd As Byte
b = mem(252)
g = mem(251)
r = mem(250)
y = mem(249)
x = mem(248)
yy = mem(247)
xx = mem(246)
pcmd = mem(253)
Select Case pcmd                            'Paint command
    Case 0:                                 'Do nothing
            Exit Sub
    Case 1:                                 'Clearscreen
            For i = 0 To 255
             For j = 0 To 255
              Pbuf(i, j) = Bcolor
             Next
            Next
    Case 2:                                 'SetBackgroundColor
            Bcolor = RGB(r, g, b)
    Case 3:                                 'Setpixel
            Pbuf(x, y) = RGB(r, g, b)
    Case 4:                                 'Getpixel
            C = Pbuf(x, y)
            b = (C And 16711680) / 65536
            g = (C And 65280) / 256
            r = C And 255
            mem(252) = b
            mem(251) = g
            mem(250) = r
    Case 5:                                 'Line
            Pline x, xx, y, yy, RGB(r, g, b)
End Select
mem(253) = 0
If Not Form6 Is Nothing Then
Form6.RefreshScreen
End If
End Sub

Sub Pline(x0, x1, y0, y1, color)
    Dim steep As Boolean
    Dim deltax As Integer, deltay As Integer
    Dim error As Double, detaerr As Double
    Dim ystep As Integer, y As Integer
    steep = (Abs(y1 - y0) > Abs(x1 - x0))
    If steep Then
        t = x0
        x0 = y0
        y0 = t
        t = x1
        x1 = y1
        y1 = t
    End If
    If x0 > x1 Then
        t = x0
        x0 = x1
        x1 = t
        t = y0
        y0 = y1
        y1 = t
    End If
    deltax = x1 - x0
    deltay = Abs(y1 - y0)
    error = 0
    deltaerr = deltay / deltax
    y = y0
    If y0 < y1 Then ystep = 1 Else ystep = -1
    For x = x0 To x1
        If steep Then Pbuf(y, x) = color Else Pbuf(x, y) = color
        error = error + deltaerr
        If error >= 0.5 Then
           y = y + ystep
           error = error - 1#
        End If
    Next
End Sub

Sub CheckNetwork()
On Error Resume Next
Dim IP1, IP2, IP3, IP4, PH, PL, dat, C
IP1 = mem(238)
IP2 = mem(239)
IP3 = mem(240)
IP4 = mem(241)
PH = mem(242)
PL = mem(243)
dat = mem(244)
C = mem(245)
Select Case C
    Case 0:             'Do Nothing
        Exit Sub
    Case 1:             'Connect
        With Form1.sock
        .Close
        .RemoteHost = IP1 & "." & IP2 & "." & IP3 & "." & IP4
        .RemotePort = PH * 256 + PL
        .Connect
        End With
    Case 2:             'Send Data
        With Form1.sock
        .SendData Chr(dat)
        mem(244) = 0
        End With
    Case 3:             'Receive Data
        With Form1.sock
        .Close
        .LocalPort = PH * 256 + PL
        .Listen
        End With
End Select
mem(245) = 0
End Sub
